.686p                     ; create 32 bit code
.model flat, stdcall      ; 32 bit memory model
option casemap :none      ; case sensitive
.xmm

include    \masm32\include\windows.inc
include    \masm32\include\user32.inc
include    \masm32\include\kernel32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

.data
   a         dd 8192  dup (0)  ; initially f0, f1 -> a, b
   b         dd 8192  dup (0)  ; later     f2, f3, f4, f5 -> a, b, a, b

   carry     dd 0
   max       dd 0
   eaz       dd 0
   ebz       dd 0

   fib       dd 0
   fibmax    dd 992759  ; stop at the 2749  541  47  kth fibonacci number
   arrmax    dd 8191    ; each spot in the two arrays a,b holds 9 digits, ie base 1 000 000 000
   junk      dd 0

   bothends  dd 0
   last9     dd 0   
   first9    dd 0
   first9zero  dd 0

   szTitleBnd  db "Bound reached, "
   szTitle     db "Calculated to the kth fibonacci number where k = "
   szFibk      db 256  dup (0)

   szLast9     db "The last 9 digits of the kth fibonacci number are "
   szDigLast   db 32 dup (0)

; remove just for debugging
;     szLast9     db 32

   szFirst9    db "The first 9(+) digits of the kth fibonacci number are "
   szDigFirs   db 32 dup (0)
   szDigFir2   db 32 dup (0)

   szAns       db 20480 dup (0)

   szTitle2    db "Pandigital in both first and last 9 digits on kth fibonacci number where k = "
   szFibk2     db 256  dup (0)

 ;    szTitleBnd  db "Bound reach, Calculated to the kth fibonacci number where k = "
 ;    szFibkBnd   db 256  dup (0)

   szTitle3    db "Maximum item in dword array, max = "
   szFibk3     db 256  dup (0)


; 


.code

align 4

ddtoa proc dwValue:DWORD, lpBuffer:DWORD

    ; -------------------------------------------------------------
    ; convert DWORD to ascii string
    ; dwValue is value to be converted
    ; lpBuffer is the address of the receiving buffer
    ; eax returns the offset in the string of the zero byte
    ; EXAMPLE:
    ; invoke dwtoa,edx,ADDR buffer
    ;
    ; Uses: eax, ecx, edx.
    ; -------------------------------------------------------------

    push edx
    push ecx
    push ebx
    push esi
    push edi

    mov eax, dwValue
    mov edi, [lpBuffer]

    test eax,eax
    jnz sign

  zero:
    mov word ptr [edi],30h
    jmp dtaexit

  sign:
    jns pos
    mov byte ptr [edi],'-'
    neg eax
    add edi, 1

  pos:
    mov ecx, 3435973837
    mov esi, edi

    .while (eax > 0)
      mov ebx,eax
      mul ecx
      shr edx, 3
      mov eax,edx
      lea edx,[edx*4+edx]
      add edx,edx
      sub ebx,edx
      add bl,'0'
      mov [edi],bl
      add edi, 1
    .endw

    mov byte ptr [edi], 0       ; terminate the string
    mov edx, edi
    sub edx, esi

    ; We now have all the digits, but in reverse order.

    .while (esi < edi)
      sub edi, 1
      mov al, [esi]
      mov ah, [edi]
      mov [edi], al
      mov [esi], ah
      add esi, 1
    .endw

  dtaexit:

    mov eax, edx
    pop edi
    pop esi
    pop ebx
    pop ecx
    pop edx

    ret

ddtoa endp

; 


pandigital proc lpBuffer:DWORD

    ; -------------------------------------------------------------
    ; check for pandigital, must have all 1-9 ascii digits
    ; in the first 9 numeric chars 
    ; of the zero terminated ascii string
    ; it will skip spaces and other non numeric ascii chars
    ;
    ; lpBuffer is the address of the source buffer
    ; returns either 1 or 0 in eax for True or False
    ; EXAMPLE:
    ; invoke pandigital,ADDR buffer
    ;
    ; Uses: eax returns 1, 0 for True, False
    ; -------------------------------------------------------------

    push ebx
    push ecx
    push edx
    push esi
    push edi

    mov eax, 0
    mov edx, 0
    mov edi, lpBuffer
    mov esi, lpBuffer
    mov ebx, 1022        ; set bits 1-9

    .while (byte ptr [edi] != 0) && (edx < 9)
       mov ecx, [edi]
       .if (cl >= 30h) && (cl <= 39h)
          and ecx, 15
          btr ebx, ecx   ; clear each bit found, if all 9 bits get cleared then pandigital is True
          inc edx
       .endif
       inc edi
    .endw

 ;     .if ebx == 0
 ;        mov eax, 1
 ;     .endif

 ;     bsf eax, ebx    ; if all bits in ebx are 0/clear then Z = 0
 ;     setnz al        ; if Z == 0 then eax = 1 else eax = 0

    bsf eax, ebx    ; if all bits in ebx are 0/clear then Z = 1
    setz al         ; if Z == 1 then eax = 1 else eax = 0
    movzx eax, al

  panexit:

    pop edi
    pop esi
    pop edx
    pop ecx
    pop ebx

    ret

pandigital endp









start:
   mov a, 0               ; f0
   mov fib, 0

   mov b, 1               ; f1
   inc fib

   mov max, 0

   mov ebx, offset b
   mov ebz, ebx
   mov esi, 0
   mov eax, offset a
   mov eaz, eax
   mov edi, 0

   mov edx, max
   shl edx, 2

   .repeat
 ;      for i := 0 to max do
 ;        a[i] := a[i] + b[i]
 ;
 ;      clc
 ;      for i := 0 to max do
 ;        adc a[i]
 ;        if a[i] > 999 999 999 then
 ;          a[i] := a[i] - 1 000 000 000
 ;          stc
 ;        endif;
 ;      endfor;
 ;      if c then
 ;        inc max
 ;        mov edx, max
 ;        shl edx, 2
 ;        a[max] := a[max] + 1
 ;      endif;

     mov carry, 0
   nlp:
     mov ecx, carry
     add ecx, [ebx + esi]
     add [eax + edi], ecx
     mov carry, 0

     mov ecx, [eax + edi]       ; cmp [eax + edi],  999999999
     cmp ecx, 999999999
     jbe skipsb
       sub ecx, 1000000000      ; sub [eax + edi], 1000000000
       mov [eax + edi], ecx
       mov carry, 1
   skipsb:  
     add esi, 4
     add edi, 4
     cmp esi, edx
     jbe nlp

     cmp carry, 0
     je  skipmx
       inc max                 ; do  if carry == 1
       mov edi, max
       mov ecx, 1              ; preload  + 1
       shl edi, 2
       mov edx, edi
       add [eax + edi], ecx    ;  a[max] := a[max] + 1    can it be , 1 ?  No
    skipmx:
     inc fib

     mov eaz, eax                               ; save the pointers to the both arrays
     mov ebz, ebx





     mov ecx, fib
     and ecx, 8191     ; 16383
     .if ecx == 8191
        invoke Sleep, 10
     .endif

     mov ecx, eaz                               ; get the last 9 digits
     mov ecx, [ecx]
      add ecx, 1000000000
     invoke ddtoa, ecx, ADDR szDigLast
      mov szDigLast, 32

     invoke pandigital, ADDR szDigLast          ; pandigital test
     mov last9, eax

; remove just for debugging
 ;      .if fib == 2749
 ;         nop
 ;         nop
 ;         mov ecx, ecx
 ;         nop
 ;         nop
 ;      .end

; remove just for debugging
 ;      mov last9, 1

     .if (last9 >= 1)                           ; only check for first 9 if last 9 are pandigital
     mov edi, max
     shl edi, 2
 ;      nop
 ;      nop
     mov ecx, eaz                               ; get first 9 or less digits
     mov ecx, [ecx + edi - 0]
;    ; add ecx, 1000000000
     invoke ddtoa, ecx, ADDR szDigFirs          ; can be less than 9 digits, no leading zeros
;    ; mov szDigFirs, 32
     mov first9zero, eax                        ; eax has offset to string zero byte

     mov ecx, eaz
     mov ecx, [ecx + edi - 4]
      add ecx, 1000000000                       ; add billion to enable leading zeros
     invoke ddtoa, ecx, ADDR szDigFir2
      mov szDigFir2, 32                         ; replace leading 1 with space

     mov esi, offset szDigFirs
     add esi, first9zero
     mov ecx, dword ptr szDigFir2 + 1           ; copy 4 bytes of string, skip first byte
     mov [esi], ecx                             ; append to string from first 9 or less digits
     add esi, 4
     mov ecx, dword ptr szDigFir2 + 1 + 4       ; copy 4 bytes
     mov [esi], ecx
     add esi, 4
     mov ecx, dword ptr szDigFir2 + 1 + 8       ; copy 4 bytes 1 in string and 3 after
     mov [esi], ecx

     invoke pandigital, ADDR szDigFirs          ; pandigital test
     mov first9, eax
     .endif


     .if (last9 >= 1) && (first9 >= 1)          ; last9 > 0
        invoke ddtoa, fib, ADDR szFibk2
        invoke MessageBox,NULL,ADDR szLast9 ,ADDR szTitle2,MB_OK   ; ADDR szFibk2
     .endif   





 ;      call checklast9     ; not written yet
 ;      call checkfirst9    ; not written yet

     mov edx, last9
     add edx, first9
     mov bothends, edx

     mov ecx, fibmax        ; check if reached maximum kth fib search bound
     .if fib >= ecx
        mov bothends, 3
     .endif

     mov ecx, max           ; check if reached maximum storage for holding a fibonacci number
     .if ecx >= arrmax
        mov bothends, 3
     .endif


     mov eax, eaz
     mov ebx, ebz

     .if bothends < 2
        mov last9, 0
        mov first9, 0

        mov edx, max
        shl edx, 2

        mov esi, 0
        mov edi, 0
        xchg eax, ebx
     .endif

   .until bothends >= 2







   invoke ddtoa, fib, ADDR szFibk
;remove just for debugging
 ;    invoke ddtoa, fib, ADDR szFibkBnd


;remove just for debugging
 ;    mov ecx, eaz
 ;    mov ecx, [ecx]
 ;     add ecx, 1000000000
 ;    invoke ddtoa, ecx, ADDR szAns
 ;     mov szAns, 32
 ; 
 ;      mov edi, max
 ;      shl edi, 2
 ;      mov ecx, eaz                               ; get first 9 or less digits
 ;      mov ecx, [ecx + edi]
 ; ;      add ecx, 1000000000
 ;      invoke ddtoa, ecx, ADDR szAns              ; can be less than 9 digits, no leading zeros

;remove just for debugging
 ;    mov ecx, offset szDigFirs
   
   .if bothends == 2
      invoke MessageBox,NULL,ADDR szFirst9,ADDR szTitle,MB_OK
      invoke MessageBox,NULL,ADDR szLast9, ADDR szTitle,MB_OK
   .else
      invoke MessageBox,NULL,ADDR szLast9,ADDR szTitleBnd,MB_OK
   .endif

 ;    .if bothends == 2
 ;       invoke MessageBox,NULL,ADDR szDigFirs,ADDR szTitle,MB_OK
 ;    .else
 ;       invoke MessageBox,NULL,ADDR szDigFirs,ADDR szTitleBnd,MB_OK
 ;    .endif

;remove just for debugging
 ;    invoke MessageBox,NULL,ADDR szDigFirs,ADDR szTitleBnd,MB_OK
 ;    invoke MessageBox,NULL,ADDR szDigFir2,ADDR szTitleBnd,MB_OK

;remove just for debugging
   invoke ddtoa, max, ADDR szFibk3
   invoke MessageBox,NULL,ADDR szFibk3,ADDR szTitle3,MB_OK

   invoke  ExitProcess, 0

end start